//+------------------------------------------------------------------+
//|                                   Indicator: MACrossover EMA.mq4 |
//|                                       Created with EABuilder.com |
//|                                        https://www.eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "https://www.eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 clrYellow //0x1E962A
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x1717FF
#property indicator_label2 "Sell"
input  bool Horizontallines=true;
input  bool Verticallines =false;
//--- indicator buffers
double Buffer1[];
double Buffer2[];
extern color BuyLine_Color          = clrBlue; //Color of the lines
extern color SellLine_Color          = clrRed; //Color of the lines

input ENUM_LINE_STYLE Line_Style = STYLE_DASH;
extern int FastMA = 20;
extern int SlowMA = 50;
datetime time_alert; //used when sending alert
extern bool Send_Email = true;
extern bool Audible_Alerts = true;
extern bool Push_Notifications = true;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | MACrossover EMA @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
   else if(type == "indicator")
     {
      if(Audible_Alerts) Alert(type+" | MACrossover EMA @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
      if(Send_Email) SendMail("MACrossover EMA", type+" | MACrossover EMA @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
      if(Push_Notifications) SendNotification(type+" | MACrossover EMA @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexArrow(0, 233);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexArrow(1, 234);
   ObjectsDeleteAll();
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, EMPTY_VALUE);
      ArrayInitialize(Buffer2, EMPTY_VALUE);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(70000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      
      //Indicator Buffer 1
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_EMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_EMA, PRICE_CLOSE, i+1) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i+1) //Moving Average crosses above Moving Average
      )
        {
         Buffer1[i] = Close[i]; //Set indicator value at Candlestick Close
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "Buy"); //Alert on next bar open
         time_alert = Time[1];
         string BuyHorLin="HBUYLINE"+string(Time[i]);
         string BuyVerLin="VBUYLINE"+string(Time[i]);
        
          
           
            if(Horizontallines && (ObjectFind(BuyVerLin) != 0))
            {
            
            ObjectCreate(BuyVerLin, OBJ_VLINE, 0, Time[i], 0);
            ObjectSetInteger(0,BuyVerLin,OBJPROP_STYLE,Line_Style);
            ObjectSet(BuyVerLin, OBJPROP_COLOR, BuyLine_Color);
            }
            
            if(Verticallines && (ObjectFind(BuyHorLin) != 0))
            {
            ObjectCreate(BuyHorLin, OBJ_HLINE, 0, Time[20], Close[i]);
            ObjectSet(BuyHorLin, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(BuyHorLin, OBJPROP_COLOR, BuyLine_Color);
            
           
            }
            
         
         
         
        }
      else
        {
         Buffer1[i] = EMPTY_VALUE;
        }
      //Indicator Buffer 2
      if(iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_EMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, FastMA, 0, MODE_EMA, PRICE_CLOSE, i+1) > iMA(NULL, PERIOD_CURRENT, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i+1) //Moving Average crosses below Moving Average
      )
        {
         Buffer2[i] = Close[i]; //Set indicator value at Candlestick Close
         if(i == 1 && Time[1] != time_alert) myAlert("indicator", "Sell"); //Alert on next bar open
         time_alert = Time[1];
         string SellHorLin="HSELLLINE"+string(Time[i]);
         string SellVerLin="VSELLLINE"+string(Time[i]);
        
          
           
            if(Horizontallines && (ObjectFind(SellVerLin) != 0))
            {
            
            ObjectCreate(SellVerLin, OBJ_VLINE, 0, Time[i], 0);
            ObjectSetInteger(0,SellVerLin,OBJPROP_STYLE,Line_Style);
            ObjectSet(SellVerLin, OBJPROP_COLOR, BuyLine_Color);
            }
            
            if(Verticallines && (ObjectFind(SellHorLin) != 0))
            {
            ObjectCreate(SellHorLin, OBJ_HLINE, 0, Time[20], Close[i]);
            ObjectSet(SellHorLin, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(SellHorLin, OBJPROP_COLOR,SellLine_Color);
            
           
            }
         
         
         /*
          string SellLin="SELLLINE"+string(Time[i]);
        
          if (ObjectFind(SellLin) != 0)
         {
            ObjectCreate(SellLin, OBJ_VLINE, 0, Time[i], 0);
            ObjectSetInteger(0,SellLin,OBJPROP_STYLE,Line_Style);
            ObjectSet(SellLin, OBJPROP_COLOR, SellLine_Color);
         }
        */
        }
      else
        {
         Buffer2[i] = EMPTY_VALUE;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+